#pragma vertex vert
#pragma fragment frag
#pragma pc_length 12

struct VertexOutput
{
    float4 Position : SV_Position;
    float4 Color : COLOR;
};

struct PushConstants
{
    float3 cyano_color;
};

[[vk::push_constant]]
PushConstants pc;

VertexOutput vert(uint id : SV_VertexID)
{
    VertexOutput output;
    
    float2 positions[6] =
    {
        float2(-0.5f, -0.5f),
        float2(0.5f, 0.5f),
        float2(-0.5f, 0.5f),
        
        float2(-0.5f, -0.5f),
        float2(0.5f, -0.5f),
        float2(0.5f, 0.5f),
    };

    float3 colors[6] =
    {
        float3(1.0f, 0.0f, 0.0f),
        float3(0.0f, 1.0f, 0.0f),
        float3(0.0f, 1.0f, 1.0f),
        
        float3(1.0f, 0.0f, 0.0f),
        float3(0.0f, 1.0f, 1.0f),
        float3(0.0f, 1.0f, 0.0f),
    };
    
    colors[2] = pc.cyano_color;
    colors[4] = pc.cyano_color;
    
    output.Position = float4(positions[id], 0.0f, 1.0f);
    output.Color = float4(colors[id], 1.0f);
    
    return output;
}

float4 frag(VertexOutput v) : SV_Target
{
    return v.Color;
}